/*
 * File         : AdlibPrintStream.java
 * Author       : Guansong Zhang
 * Created      : Mon Jan 12 10:37:28 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/01/12 17:42:58 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

package adlib;

import adlib.*;
import java.io.*;

public class AdlibPrintStream extends PrintStream {

  AdlibPrintStream (OutputStream _out) {
    super(_out); //deprecated API, but nothing better for the moment?
  }

  /*
  AdlibPrintStream (OutputStream _out, boolean autoFlush) {
    super(_out, autoFlush); //deprecated API, but nothing better for the moment?
  }
  */

  public void print(char x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(int x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(long x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(float x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(double x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(char[] x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(String x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void print(Object x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println() {
    if (Adlib.apg.id()==0)
      System.out.println();
  }
  public void println(char x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(int x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(long x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(float x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(double x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(char[] x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(String x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }
  public void println(Object x) {
    if (Adlib.apg.id()==0)
      System.out.println(x);
  }

}
