/*
 * File         : adlib_InterfaceObject.C
 * Author       : Guansong Zhang
 * Created      : Tue Oct 21 11:23:32 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1997/10/21 20:26:31 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "adlib_InterfaceObject.h"

jfieldID hCPPObjID=0;

/*
 * Class:     adlib_InterfaceObject
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_InterfaceObject_init
  (JNIEnv * env, jobject jthis)
{
  jclass InterfaceObject_class=env->FindClass("adlib/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
};
