// created by Zheng Gengbin

#define STATIC_BUFFER_SIZE 262144
//#define STATIC_BUFFER_SIZE 9

  // add by Zheng Gengbin
extern int IclaSize;

extern int storageMode;
extern int defaultStorageMode;
extern int reduceMode; //add wjp 0--initial, 1--in reduce intrinsic function process

enum Status { IN_CORE, OUT_OF_CORE };

#define PASSION_CCPLUSPLUS

#define OC_SUM 0
#define OC_MAXVAL 1
#define OC_MINVAL 2
#define OC_MAXLOC 3
#define OC_MINLOC 4
#define OC_ANY    5
#define OC_ALL    6
#define OC_COUNT  7

#define ANY       10
#define ALL       11
#define COUNT     12

#define ADLIB_INTEGER		1
#define ADLIB_REAL		2
#define ADLIB_DOUBLE		3
#define ADLIB_CHARACTER		4
#define ADLIB_COMPLEX		5
#define ADLIB_LOGICAL		6
#define ADLIB_BYTE		7
#define ADLIB_WORD		8


inline int typeLen(int type)
{
   switch (type) 
   {
   case 0:
		return 0;
   case ADLIB_INTEGER: 
   case ADLIB_REAL:
   case ADLIB_LOGICAL:
		return 4;
   case ADLIB_DOUBLE:
   case ADLIB_COMPLEX:
		return 8;
   case ADLIB_CHARACTER:
   case ADLIB_BYTE:
		return 1;
   }
   return 0;
}

#ifndef HAVE_CONFIG_H
extern "C" {
  double log(...);
  double exp(...);
  double sqrt(...);
  extern "C" void exit(...);
}
#endif
