      PROGRAM LAPLACE
      INTEGER N
      PARAMETER(N=300)

	integer A(N,N),B(N,N),C(N,N)
!HPF$ PROCESSORS PROC(4)
!HPF$ TEMPLATE TEMP(N,N) 
!HPF$ DISTRIBUTE TEMP(BLOCK,*) ONTO PROC
!HPF$ ALIGN A(i,j) with TEMP(i,j)
!HPF$ ALIGN B(i,j) with TEMP(i,j)
!HPF$ ALIGN C(i,j) with TEMP(i,j)

	forall(i=1:N,j=1:N) C(i,j)=i-j

	call pcrc_clock(0)
!HPF$ INDEPENDENT
	do j=1,N
!HPF$ INDEPENDENT
	do i=1,N
		A(i,j)=C(i,j)+100
		
		if(C(i,j).eq.0) then
			B(i,j)=0
		else if(C(i,j).ge.0) then
			B(i,j)=2*C(i,j)
		else
			B(i,j)=-2*C(i,j)
		end if
	end do
	end do
	call pcrc_clock(1)

!check result
	if(N==16) then
	print *,"C:"
	do i=1,N
		print *,(C(i,j),j=1,N)
	end do

	print *,"A:"
	do i=1,N
		print *,(A(i,j),j=1,N)
	end do

	print *,"B:"
	do i=1,N
		print *,(B(i,j),j=1,N)
	end do
	end if

      END
