      PROGRAM LAPLACE
      INTEGER N
      PARAMETER(N=16)
      INTERFACE
        SUBROUTINE add(a,n)
	  integer,intent(IN)			   :: n	
          INTEGER,dimension(n),INTENT(INOUT)       :: a
        END SUBROUTINE add 
      END INTERFACE

	integer A(N,N),B(N,N),C(N,N,N)
!HPF$ PROCESSORS PROC(4)
!HPF$ TEMPLATE TEMP(N,N) 
!HPF$ DISTRIBUTE TEMP(BLOCK,*) ONTO PROC
!HPF$ ALIGN A(i,j) with TEMP(i,j)
!HPF$ ALIGN B(i,j) with TEMP(i,j)
!HPF$ DISTRIBUTE C(*,BLOCK,*) ONTO PROC
!hpf$ out_of_core C

	call pcrc_clock(0)
!HPF$ INDEPENDENT
	do i=1,N
!HPF$ INDEPENDENT
	do j=1,N
		A(i,j)=0

		!call add(C(:,i,j),N)
	  	do k=1,10
			C(k,i,j)=0
		end do
		do k=3,N
			A(i,j)=A(i,j)+C(k,i,j)
		end do
	end do
	end do
	call pcrc_clock(1)

!now test if it is handled correctly
	if(N==16) then
		print *,"C(:,1,1)",(C(k,1,1),k=1,N)
		print *,"sum:",A(1,1)	
	end if

      END

	subroutine add(a,n)
	integer,intent(IN)                       :: n
          INTEGER,dimension(n),INTENT(INOUT)       :: a
	do i=1,n
		a(i)=i**3+i**2+i+1
	end do
	return
	end subroutine add
