#include "compilerApi.h"
#include "../../depInterface.h"
#include "tool.h"

main(int argc,char **argv)
{
   
   char *args[2];
   SgStatement *pSgStmt,*pStmt;
   SgProject *pProject;
   SgFile *pFile;
   depNode *pDep;
   int fromID,toID;
   int i,j;

   args[1]=argv[1];
   pProject= new SgProject("",argc,argv);
   pFile=&(pProject->file(0));

   for(pStmt=pFile->firstStatement();pStmt;pStmt=pStmt->lexNext())
	{
          pStmt->unparsestdout();
          printf("the id is %d\n",pStmt->id());
        }    	
   initializeDepToolKit(pProject);
   
   printf("input two IDs: fromID toID to test dependence\n");
   scanf("%d %d",&fromID,&toID);
   printf("begin\n");
   pDep=isDependentBetweenStmts(fromID,toID);  		
   printf("end\n");
   if(pDep)
	{
           //pDep->displayDep();
           printf("the lengthvect is %d \n",pDep->lenghtvect);
           printf("the kinddep is %d \n",pDep->kinddep);
           for(i=1;i<=pDep->lenghtvect;i++)
            {
              printf("the %d th distance value is %d\n",i,pDep->distance[i]); 
              printf("the %d th knowdist value is %d\n",i,pDep->knowndist[i]);
            } 
        } 
   else printf("NULL dep\n");	
  
   finalizeDepToolKit(); 
   
   delete pProject;	
}

