#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/DialogS.h>
#include <Xm/MessageB.h>
#include <stdio.h>

#define N 20

#define FORALL_DLG_WIDTH  320
#define FORALL_DLG_HEIGHT 320
#define FORALL_DLG_MARGIN 20
#define FORALL_OK_WIDTH   40 
#define FORALL_OK_HEIGHT  30  

#define FOR_DLG_WIDTH  320
#define FOR_DLG_HEIGHT 320
#define FOR_DLG_MARGIN 20
#define FOR_OK_WIDTH   40 
#define FOR_OK_HEIGHT  30  

extern char *readFile (char *pFileToShow);

void  forall_ok_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void  forallconstruct_ok_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void  for_ok_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);

Widget create_Forall_dlg(Widget parent_w,char *pFileToShow)
{
   Widget dlg_shell,dlg_w,label_w,text_w,form_w,ok_w;
   XmString label_text,Title;
   char *pRaw="If your forall statement is  translated into\n the following form  there  will be data dependence .\nYou are recommended to remove the dependence \nocurred in this statement";
   Arg  args[N];
   char *pText;
   int  n;

   n=0; 
   Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNtitle,Title);n++;
   dlg_shell=XmCreateDialogShell(parent_w,"DialogShell",args,n);
   XmStringFree(Title);

   n=0;
   //Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNautoUnmanage,True);n++;
   //XtSetArg(args[n],XmNresizePolicy,XmRESIZE_NONE);n++;
   //XtSetArg(args[n],XmNdialogTitle,Title);n++;
   XtSetArg(args[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
   //dlg_w=XmCreateBulletinBoard(parent_w,"ForallDialog",args,n);
   dlg_w=XmCreateBulletinBoard(dlg_shell,"ForallDialog",args,n);
   //XmStringFree(Title);

/*
   n=0;
   XtSetArg(args[n],XmNwidth,FORALL_DLG_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FORALL_DLG_HEIGHT);n++;
   XtSetArg(args[n],XmNtopOffset,FORALL_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNbottomOffset,FORALL_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNresizePolicy,XmRESIZE_NONE);n++;
   XtSetArg(args[n],XmNautoUnmanage,False);n++;
   //XtSetArg(args[n],XmNdialogTitle,"Vdep");n++;
   form_w=XmCreateFormDialog(parent_w,"ForallForm",args,n);
   XtManageChild(form_w);
*/

   n=0;
   XtSetArg(args[n],XmNwidth,FORALL_DLG_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FORALL_DLG_HEIGHT);n++;
   XtSetArg(args[n],XmNtopOffset,FORALL_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNbottomOffset,FORALL_DLG_MARGIN);n++;
   form_w=XmCreateForm(dlg_w,"ForallForm",args,n);
   XtManageChild(form_w);

   label_text=XmStringCreateLtoR(pRaw,XmSTRING_DEFAULT_CHARSET);
   n=0;
   XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNbottomPosition,20);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNlabelString,label_text);n++;
   label_w=XmCreateLabel(form_w,"ForallLabel",args,n);
   XmStringFree(label_text);
   XtManageChild(label_w);
   
   n=0;
   XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNtopPosition,21);n++; 
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNbottomPosition,80);n++;
   XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNrows,20);n++;
   XtSetArg(args[n],XmNcolumns,30);n++;
   XtSetArg(args[n],XmNeditable,False);n++;
   text_w=XmCreateScrolledText(form_w,"ForallText",args,n);
   XtManageChild(text_w);
   pText=readFile(pFileToShow);
   XmTextSetString(text_w,pText);

   n=0;
   label_text=XmStringCreateSimple("OK");
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNleftPosition,45);
   XtSetArg(args[n],XmNwidth,FORALL_OK_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FORALL_OK_HEIGHT);n++;
   XtSetArg(args[n],XmNlabelString,label_text);n++;
   ok_w=XmCreatePushButton(form_w,"ForallOK",args,n);
   XmStringFree(label_text);
   XtManageChild(ok_w);
   XtAddCallback(ok_w,XmNactivateCallback,(XtCallbackProc)forall_ok_fn,(XtPointer)NULL);

   delete pText;
   return dlg_w;
}

void  forall_ok_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
	XtDestroyWidget(XtParent(XtParent(XtParent(w)))); 	
}

/* this is roughly the same with create_forall_dlg**/

Widget create_ForallConstruct_dlg(Widget parent_w,char *pFileToShow)
{
   Widget dlg_shell,dlg_w,label_w,text_w,form_w,ok_w;
   XmString label_text,Title;
   char *pRaw="There will be dependence of the following like \n If your forallconstruct statement is  translated into\n the following form  ";
   Arg  args[N];
   char *pText;
   int  n;

   n=0; 
   Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNtitle,Title);n++;
   dlg_shell=XmCreateDialogShell(parent_w,"DialogShell",args,n);
   XmStringFree(Title);

   n=0;
   //Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNautoUnmanage,True);n++;
   //XtSetArg(args[n],XmNresizePolicy,XmRESIZE_NONE);n++;
   //XtSetArg(args[n],XmNdialogTitle,Title);n++;
   XtSetArg(args[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
   //dlg_w=XmCreateBulletinBoard(parent_w,"ForallConstructDialog",args,n);
   dlg_w=XmCreateBulletinBoard(dlg_shell,"ForallConstructDialog",args,n);
   //XmStringFree(Title);

   n=0;
   XtSetArg(args[n],XmNwidth,FORALL_DLG_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FORALL_DLG_HEIGHT);n++;
   XtSetArg(args[n],XmNtopOffset,FORALL_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNbottomOffset,FORALL_DLG_MARGIN);n++;
   form_w=XmCreateForm(dlg_w,"ForallForm",args,n);
   XtManageChild(form_w);

   label_text=XmStringCreateLtoR(pRaw,XmSTRING_DEFAULT_CHARSET);
   n=0;
   XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNbottomPosition,20);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNlabelString,label_text);n++;
   label_w=XmCreateLabel(form_w,"ForallLabel",args,n);
   XmStringFree(label_text);
   XtManageChild(label_w);
   
   n=0;
   XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNtopPosition,21);n++; 
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNbottomPosition,80);n++;
   XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNrows,20);n++;
   XtSetArg(args[n],XmNcolumns,30);n++;
   XtSetArg(args[n],XmNeditable,False);n++;
   text_w=XmCreateScrolledText(form_w,"ForallText",args,n);
   XtManageChild(text_w);
   pText=readFile(pFileToShow);
   XmTextSetString(text_w,pText);

   n=0;
   label_text=XmStringCreateSimple("OK");
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNleftPosition,45);
   XtSetArg(args[n],XmNwidth,FORALL_OK_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FORALL_OK_HEIGHT);n++;
   XtSetArg(args[n],XmNlabelString,label_text);n++;
   ok_w=XmCreatePushButton(form_w,"ForallOK",args,n);
   XmStringFree(label_text);
   XtManageChild(ok_w);
   XtAddCallback(ok_w,XmNactivateCallback,(XtCallbackProc)forallconstruct_ok_fn,(XtPointer)NULL);

   delete pText;
   return dlg_w;
}

void  forallconstruct_ok_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
	XtDestroyWidget(XtParent(XtParent(XtParent(w)))); 	
}

/**this is roughly the same with create_Forall_dlg.**/

Widget create_For_dlg(Widget parent_w,char *pFileToShow)
{
   Widget dlg_shell,dlg_w,label_w,text_w,form_w,ok_w;
   XmString label_text,Title;
   char *pRaw="The dependence information is :";
   Arg  args[N];
   char *pText;
   int  n;

   n=0; 
   Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNtitle,Title);n++;
   dlg_shell=XmCreateDialogShell(parent_w,"DialogShell",args,n);
   XmStringFree(Title);

   n=0;
   //Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNautoUnmanage,True);n++;
   //XtSetArg(args[n],XmNresizePolicy,XmRESIZE_NONE);n++;
   //XtSetArg(args[n],XmNdialogTitle,Title);n++;
   XtSetArg(args[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
   //dlg_w=XmCreateBulletinBoard(parent_w,"ForDialog",args,n);
   dlg_w=XmCreateBulletinBoard(dlg_shell,"ForDialog",args,n);
   //XmStringFree(Title);

/*
   n=0;
   XtSetArg(args[n],XmNwidth,FOR_DLG_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FOR_DLG_HEIGHT);n++;
   XtSetArg(args[n],XmNtopOffset,FOR_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNbottomOffset,FOR_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNresizePolicy,XmRESIZE_NONE);n++;
   XtSetArg(args[n],XmNautoUnmanage,False);n++;
   //XtSetArg(args[n],XmNdialogTitle,"Vdep");n++;
   form_w=XmCreateFormDialog(parent_w,"ForForm",args,n);
   XtManageChild(form_w);
*/

   n=0;
   XtSetArg(args[n],XmNwidth,FOR_DLG_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FOR_DLG_HEIGHT);n++;
   XtSetArg(args[n],XmNtopOffset,FOR_DLG_MARGIN);n++;
   XtSetArg(args[n],XmNbottomOffset,FOR_DLG_MARGIN);n++;
   form_w=XmCreateForm(dlg_w,"ForForm",args,n);
   XtManageChild(form_w);

   label_text=XmStringCreateLtoR(pRaw,XmSTRING_DEFAULT_CHARSET);
   n=0;
   XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNbottomPosition,20);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNlabelString,label_text);n++;
   label_w=XmCreateLabel(form_w,"ForallLabel",args,n);
   XmStringFree(label_text);
   XtManageChild(label_w);
   
   n=0;
   XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNtopPosition,21);n++; 
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNbottomPosition,80);n++;
   XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNrows,20);n++;
   XtSetArg(args[n],XmNcolumns,30);n++;
   XtSetArg(args[n],XmNeditable,False);n++;
   text_w=XmCreateScrolledText(form_w,"ForallText",args,n);
   XtManageChild(text_w);
   pText=readFile(pFileToShow);
   XmTextSetString(text_w,pText);

   n=0;
   label_text=XmStringCreateSimple("OK");
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
   XtSetArg(args[n],XmNleftAttachment,XmATTACH_POSITION);n++;
   XtSetArg(args[n],XmNleftPosition,45);
   XtSetArg(args[n],XmNwidth,FOR_OK_WIDTH);n++;
   XtSetArg(args[n],XmNheight,FOR_OK_HEIGHT);n++;
   XtSetArg(args[n],XmNlabelString,label_text);n++;
   ok_w=XmCreatePushButton(form_w,"ForOK",args,n);
   XmStringFree(label_text);
   XtManageChild(ok_w);
   XtAddCallback(ok_w,XmNactivateCallback,(XtCallbackProc)for_ok_fn,(XtPointer)NULL);

   delete pText;
   return dlg_w;
}

void  for_ok_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
	XtDestroyWidget(XtParent(XtParent(XtParent(w)))); 	
}


Widget createMessageOKDialog(Widget parent_wid,char *pMsg)
{
   Widget dlg_shell,dlg_w,remove_w;
   XmString msg_text,Title;
   Arg  args[N];
   int  n;

   n=0; 
   Title=XmStringCreateSimple("Tip");
   XtSetArg(args[n],XmNtitle,Title);n++;
   dlg_shell=XmCreateDialogShell(parent_wid,"DialogShell",args,n);
   XmStringFree(Title);

   msg_text=XmStringCreateSimple(pMsg);
   n=0;
   XtSetArg(args[n],XmNmessageString,msg_text);n++;
   dlg_w=XmCreateMessageBox(dlg_shell,"NoDepDialog",args,n);
   XmStringFree(msg_text);

   remove_w=XmMessageBoxGetChild(dlg_w,XmDIALOG_HELP_BUTTON);
   XtUnmanageChild(remove_w);
   remove_w=XmMessageBoxGetChild(dlg_w,XmDIALOG_CANCEL_BUTTON);
   XtUnmanageChild(remove_w);

   return dlg_w;
}

