#include <Xm/Xm.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>

/***read the file:progPath into memory,started at pText*****/
char * readFile(char *progPath)
{
  struct stat statb;
  FILE *fProg;
  char *pText;
  
  /***open file and allocate enough space***/
  if(stat(progPath, &statb) == -1)
  {
     printf("error in getting the status of the file:%s\n",progPath);
     return(NULL);
  }
  if(NULL==(fProg=fopen(progPath,"rt")))
  {
     printf("error in opening file:%s",progPath);
     return(NULL);
  }
  if(!(pText =XtMalloc((unsigned)(statb.st_size+1)))) 
  {  
     printf("Can't allocate enough space for %s\n",progPath); 
     fclose(fProg);
     return(NULL);
  }

  /***read in the file***/
  if(!fread(pText, sizeof(char), statb.st_size+1, fProg))
  {
     printf("File read error\n");
     fclose(fProg);
     return(NULL);
  }
   pText[statb.st_size] = 0; 

 
  /***clear up***/ 
  fclose(fProg); 
  return pText;
}
