//
//	Prof.h
//		Define interfacing functions for performance visualization
//

#ifndef _PROF_H
#define _PROF_H

///////////////////////////////////////////////////////////
//	function
int LoadProfInfo(char *lpszProfFile);
int CloseProfInfo();
int IsProfInfoLoaded();

int PrepareStmtList();
int ShowStmtList();
int PrepareStmtDetail(int nStmtID);
int ShowStmtDetail(int nStmtID);

int PrepareGeneralInfo();
int ShowGeneralInfo();

int PrepareCommGraph(int nStmtID);
int ShowCommGraph(int nStmtID);

int PrepareEventGraph();
int ShowEventGraph(int bAnnimate);

int PrepareDataLayout();
int ShowDataLayout(int nSymbolID);
int PrepareDataComm();
int ShowDataComm(int nSymbolID, int nStmtID);

int ProfSelBFND(int nStmtID);

#endif
