#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>


#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "tags.h"

  /*  tag of DISPLAY BIF_TREE    */
/*
#define DEBUG         
*/

#define PANEL_X  120
#define PANEL_Y   40
#define MARGIN_X   4
#define MARGIN_Y   5
#define BT_WIDTH  (PANEL_X-2*MARGIN_X)
#define BT_HEIGHT  (PANEL_Y-2*MARGIN_Y)

#define LINEMARGIN_X 20

#define GetXByDepth(depth)     ( (depth*PANEL_X/2)+MARGIN_X )
#define GetYByHeight(height)   ( (height*PANEL_Y)+MARGIN_Y )

#define MAXHEIGHT 800

#define GETY(y)     (y)*40+15
#define COL_X1       10
#define COL_X2       200
#define LABEL_WIDTH  180
#define BUTTON_WIDTH 430
#define LABEL_HEIGHT 30

#define BOOL int
struct tree_node
{
  PTR_BFND   bfnd;
  int        parent,son,elder,younger;
  BOOL       show;
  int        depth ,height;
  int        nson;
  int        lastson;            /* used when construct elder link  */
};

struct tree_llnd
{
 PTR_LLND    llnd;
 int         depth ,height;
 int         parent;
};

struct t_call {
  Widget  w;
  int     no;
};

typedef struct _list_node {
  PTR_LLND            llnd;
  struct _list_node   *son1,*son2;
  int                 depth,height;
  struct _list_node   *right;
} LIST_NODE;

typedef struct _list_node  *NODE_PTR;

typedef struct _list_llnd {
  struct _list_llnd  *next;
  int                 num,no;
  NODE_PTR            right;
} LIST_LLND;
 
typedef LIST_LLND *LIST_PTR;

typedef struct tree_node   *BIF_TREE;
typedef struct tree_llnd   *LLND_TREE;

extern int nBIF,nBIF_show;
extern BIF_TREE  b_tree;
extern Widget    topLevel, notifyText, drawArea,notify_sym,
			scrollText,notify_llnd;
extern PTR_FILE  ptr_file;
extern char      *tag[];
extern LLND_TREE l_tree;
extern int       nLLND;
extern int       curBFND;
extern int       cur_g_line;
extern char     *fileBuf;
extern XmFontList    fontlist;

typedef struct _stack {
	Widget  ok;
	 struct _stack * next;
} STACK_ELE;

typedef STACK_ELE * PTR_STACK;

extern int begin_session();
extern int display();
extern int preprocess();
extern LIST_PTR proc_multi_llnd_tree();

extern BOOL  ll_has_ll();
extern void  help_callback();

extern void show_BFND_dlg();
extern void show_BFND_dlg1();
extern void show_SYM_dlg();
extern void show_SYM_dlg1();
extern void show_SYM_dlg2();
extern void show_TYPE_dlg();
extern void show_LLND_dlg();
extern void show_LLND_dlg1();
extern void show_LLND_dlg2();
extern void show_multi_LLND_dlg1();
extern void show_multi_LLND_dlg2();
extern void show_multi_LLND_dlg3();
extern void show_LABEL_dlg();
extern void show_LABEL_dlg1();
extern void show_LABEL_dlg2();
extern void show_CMNT_dlg1();

extern void closed();
extern Widget create_label1();
extern Widget create_label2();
extern Widget create_button();
