#ifndef _MPIDEF_H
#define _MPIDEF_H

#define _MPI_Send(buf, len, type, id, dat, com) \
	{ \
		ProfNewEvent(stat_send, id, len*4); \
		MPI_Send(buf, len, type, id, dat, com); \
		ProfEndEvent(stat_send); \
	}
#define _MPI_Isend(buf, len, type, id, dat, com, event) \
	{ \
		ProfNewEvent(stat_send, id, len*4); \
		MPI_Isend(buf, len, type, id, dat, com, event); \
		ProfEndEvent(stat_send); \
	}
#define _MPI_Irecv(buf, len, type, id, dat, com, event) \
	{ \
		ProfNewEvent(stat_recv, id, len*4); \
		MPI_Irecv(buf, len, type, id, dat, com, event); \
		ProfEndEvent(stat_recv); \
	}

#endif
