#ifndef _HEADERS_H
#define _HEADERS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <assert.h>

#if TIME_WITH_SYS_TIME
#include <sys/time.h>
#include <time.h>
#else
 #if HAVE_SYS_TIME_H
  #include <sys/time.h>
 #else
  #include <time.h>
 #endif
#endif

#ifdef _CPP
#include  <stl.h>
//#include <String.h>
#endif

#include "defs.h"

#ifdef _PROCINFO
#include "ProcInfo.h"
#endif

#ifdef _RUNTIME
#include "RunTime.h"
#endif

#ifdef _RUNTIMEP
#include "ProcInfo.h"
#include "RunTime.h"
#include "RunTimeP.h"
#endif

#ifdef _GLOBAL
#include "Global.h"
#endif

#ifdef _PROF_MPI
#include "MPIdef.h"
#endif
#endif
