
#include 	<stdio.h>
#include	<string.h>
#include        "global_var.h"
#include	"basic_fun.h"

char *mixstring="pcrc";

//
//generate a temporary variable by given type and in given statement block
//
SgVariableSymb	*get_temp_variable(SgStatement *hedr_stmt,SgType *type,char *idstr)
{	char	str[60];
	SgVariableSymb	*sym;
	SgStatement	*last_decl=hedr_stmt->lastDeclaration();
	sprintf(str,"%sTV%d",idstr,++index_var);
	sym=new SgVariableSymb(str,*type,*hedr_stmt);
	return(sym);
}
//
//initilize index_g and index_var
//
void	init_temp_index(SgStatement *hedr_stmt)
{
	index_g=-1;
	index_var=-1;
}
//
//get index variable used in forall header
//
SgVariableSymb 	*get_temp_index(int i,SgStatement *hedr_stmt,char *idstr)
{	
//	SgVariableSymb	*sym;
//	char 	str[60];

	SgSymbol *sym = hedr_stmt->getSymbolInCurrentScope(idstr,"TI",NULL,i);
	return (SgVariableSymb*)sym;
/*
	if (i>index_g) {
		sprintf(str,"%sTI%d",idstr,i);
                sym=new SgVariableSymb(str,*hedr_stmt);
		SgStatement * decl_stmt;
                decl_stmt=sym->makeVarDeclStmt();
		SgStatement  *last_decl=hedr_stmt->lastDeclaration();
                last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
//                sym->declareTheSymbol(*hedr_stmt);
                temp_index[i]=sym;
		index_g=i;
	}
	return temp_index[i];
*/
}

void add_int_startwith(SgProgHedrStmt * proghedr, char * string)
{
  SgType * inttype = SgTypeInt();

  SgSymbol * symb = proghedr->firstSymbolInScope();
  SgExprListExp * declist = new SgExprListExp();
  
  for ( ; symb; symb=symb->nextInScope()) {
    if (!strncmp(symb->identifier(), string, strlen(string))) {
      SgExpression * item = new SgExpression (VAR_REF, NULL, NULL, symb);
      declist->setLhs(*item);
      break;
    }
  }
  
  if (symb==NULL)
    return;
  else
    symb=symb->nextInScope();
  
  for ( ; symb; symb=symb->nextInScope()) {
    if (strncmp(symb->identifier(), string, strlen(string))==0) {
      SgExpression * item = new SgExpression (VAR_REF, NULL, NULL, symb);
      SgExpression * temp = declist;
      while (temp->operand(2)!=NULL)
	temp=temp->operand(2);
      SgExpression * link = new SgExpression (EXPR_LIST, item, NULL, NULL);
      temp->setRhs(*link);
    }
  }
  
  if (declist->length()!=0) {
      SgVarDeclStmt * decstmt = new SgVarDeclStmt(*declist, *inttype);
      SgStatement *stmt = proghedr->firstStmtForDeclaration();
      stmt->insertStmtAfter(*decstmt, *proghedr);
  }
}

void add_new_dec(SgStatement * s)
{
  SgProgHedrStmt * proghedr = (SgProgHedrStmt *) s;

  add_int_startwith(proghedr, "BD_TI");
  add_int_startwith(proghedr, "BDT");
  add_int_startwith(proghedr, "BDI");
}


