/** @name Passes in trans2
Module trans2 contains passes that transform parallel construct to forall 
statement. After trans2, node generation task is limited to an easier problem
as how to transform forall statement to do-loop.

{\small maintained by \URL[Zheng Gengbin]{http://162.105.179.137/users/zhenggb}.}
@memo - Passes performed in trans2
*/

//@{
/** enum to define pass types. 
*/
enum PassType {
/// transform Where Construct to Where Statements
	WHERE_CONSTRUCT_PASS,
/// transform Where Statement to Forall Statement
	WHERE_STMT_PASS,
	PRE_ASSIGN_PASS,
/// transform Array Assign Statement to Forall Statement
	ASSIGN_PASS,
/// transform Forall Construct to Forall Statement
         // added by slx
        FORALL_CONSTRUCT_PASS_1,
        FORALL_CONSTRUCT_PASS_2, 
        FORALL_CONSTRUCT_PASS_3,
/// transform Forall Construct to Forall Statement
        ELEMENTARY_INTRINSIC_PASS ,
	OTHER_PASS
};
//@}

#define  MUST_DELETE  50
