package adlib;

import adlib.*;

public class Group extends InterfaceObject {

  private static native void init();
  public static native void clean();

  private native void constructor();
  // public native void constructor(Procs p);

  public Group() {
    // start CPP group constructor, which may do nothing.
    constructor();
  }

  // the Procs is a subclass of Group in Java, not as in CPP.
  /*
  public Group(Procs p) {
    constructor(p);
  }
  */

  public native void finalize();

  public native boolean on();

  public native void no();

  public native int id();

  public native Group restrict(Location i);

  public native void show(String name);

  static {
    init();
  }

}

