/*
 * File         : Section.java
 * Author       : Guansong Zhang
 * Created      : Wed Oct 22 16:41:54 1997
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1998/01/13 18:22:36 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package adlib;

import adlib.*;

public class Section {

  Section(int _rank, int _type){
    rank=_rank;
    type=_type; 

  };

  protected int rank;
  protected int type; 

  // data to be assigned

  // replicated data;
  public Group group;
  public Range range[];
  public Stride stride[];


  public DAD dad;

  public int offset;

  public Object reference;

}
