/*
 * File         : adlib_CyclicRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/01/13 18:22:40 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "adlib_CyclicRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jctable<Range> adlib_Range_Table;

Range *adlib_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
CyclicRange * adlib_CyclicRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((CyclicRange *)adlib_Range_ResolvePtr(env, jthis));
}

Layout int2emu(int); //defined in adlib_BlockRange.C
