      program aaa
      integer :: pcrc_dad_B,pcrc_dad_C,pcrc_dad_A,pcrc_dad_D
      integer :: pcrc_sdd0
      integer :: pcrc_irg0,pcrc_irg1
      integer :: pcrc_lis_k,pcrc_lis_l
      integer :: pcrc_liu_k,pcrc_liu_l
      integer :: pcrc_lil_k,pcrc_lil_l
      integer :: pcrc_u00,pcrc_u01,pcrc_u10,pcrc_u11
      integer :: pcrc_v00,pcrc_v01,pcrc_v10,pcrc_v11
      integer :: pcrc_tmp_sdx01,pcrc_tmp_sdx11
      integer :: pcrc_sdx0,pcrc_sdx1
      include 'pcrc.inc'
      include 'mafdecls.inc'
      integer :: A(0:99)
      integer :: B(0:9999)
      integer :: C(0:9999)
      integer :: D(0:999999)
      integer :: pcrc_rng_TMP000(1)
      integer :: pcrc_rng_TMP001(2)
      integer :: pcrc_rng_TMP002(3)
      integer :: pcrc_grp_PROC000
      integer :: pcrc_shp_PROC000(1)
      integer :: i,j,k,l,m,n,o,p,q
      common /global/RECORD_SIZE,IN_CORE_SIZE
      IN_CORE_SIZE = 250000
      RECORD_SIZE = 250000
      call pcrc_init (COLUMN_MAJOR,0)
      call pcrc_mem_init (8000000,6000)
      pcrc_shp_PROC000(1) = pcrc_number_of_processors ()-1+1
      pcrc_grp_PROC000 = pcrc_new_group_grid (1,pcrc_shp_PROC000)
      pcrc_rng_TMP000(1) = pcrc_new_range_collapse (1,100)
      pcrc_rng_TMP001(1) = pcrc_new_range_collapse (1,100)
      pcrc_rng_TMP001(2) = pcrc_new_range_collapse (1,100)
      pcrc_rng_TMP002(1) = pcrc_new_range_collapse (1,100)
      pcrc_rng_TMP002(2) = pcrc_new_range_collapse (1,100)
      pcrc_rng_TMP002(3) = pcrc_new_range_collapse (1,100)
      pcrc_dad_A = pcrc_new_array_data (A,pcrc_integer,pcrc_size_integer&
     &,1,pcrc_grp_PROC000,COLUMN_MAJOR)
      call pcrc_set_array_align (pcrc_dad_A,1,1,100,1,0,0,0,pcrc_rng_TMP&
     &000(1))
      pcrc_dad_B = pcrc_new_array_data (B,pcrc_integer,pcrc_size_integer&
     &,2,pcrc_grp_PROC000,COLUMN_MAJOR)
      call pcrc_set_array_align (pcrc_dad_B,1,1,100,1,0,0,0,pcrc_rng_TMP&
     &001(1))
      call pcrc_set_array_align (pcrc_dad_B,2,1,100,1,0,0,0,pcrc_rng_TMP&
     &001(2))
      pcrc_dad_C = pcrc_new_array_data (C,pcrc_integer,pcrc_size_integer&
     &,2,pcrc_grp_PROC000,COLUMN_MAJOR)
      call pcrc_set_array_align (pcrc_dad_C,1,1,100,1,0,0,0,pcrc_rng_TMP&
     &001(1))
      call pcrc_set_array_align (pcrc_dad_C,2,1,100,1,0,0,0,pcrc_rng_TMP&
     &001(2))
      pcrc_dad_D = pcrc_new_array_data (D,pcrc_integer,pcrc_size_integer&
     &,3,pcrc_grp_PROC000,COLUMN_MAJOR)
      call pcrc_set_array_align (pcrc_dad_D,1,1,100,1,0,0,0,pcrc_rng_TMP&
     &002(1))
      call pcrc_set_array_align (pcrc_dad_D,2,1,100,1,0,0,0,pcrc_rng_TMP&
     &002(2))
      call pcrc_set_array_align (pcrc_dad_D,3,1,100,1,0,0,0,pcrc_rng_TMP&
     &002(3))
      pcrc_irg0 = pcrc_new_range_loop (1,100,1,1,1,pcrc_range (pcrc_dad_&
     &B,1))
      call pcrc_loop_bounds (pcrc_irg0,pcrc_lil_k,pcrc_liu_k,pcrc_lis_k)

      pcrc_irg1 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &B,2))
      call pcrc_loop_bounds (pcrc_irg1,pcrc_lil_l,pcrc_liu_l,pcrc_lis_l)

      pcrc_sdd0 = pcrc_new_array_section (2,pcrc_dad_B)
      call pcrc_set_array_triplet (pcrc_sdd0,1,2,101,1,pcrc_dad_B,1)
      call pcrc_set_array_triplet (pcrc_sdd0,2,1,100,1,pcrc_dad_B,2)
      call pcrc_coef (pcrc_dad_B,1,1,100,1,1,1,0,pcrc_u00,pcrc_v00)
      call pcrc_coef (pcrc_dad_B,2,1,100,1,1,0,0,pcrc_u01,pcrc_v01)
      pcrc_sdx0 = pcrc_v00+pcrc_v01
      if (pcrc_on (pcrc_group (pcrc_sdd0))) then 
          do  l=0,(pcrc_liu_l-pcrc_lil_l)/pcrc_lis_l,1
            pcrc_tmp_sdx01 = pcrc_sdx0
            do  k=0,(pcrc_liu_k-pcrc_lil_k)/pcrc_lis_k,1
               B(pcrc_sdx0) = 1
               pcrc_sdx0 = pcrc_sdx0+pcrc_u00
            enddo
            pcrc_sdx0 = pcrc_tmp_sdx01+pcrc_u01
         enddo
       endif
      call pcrc_delete_array (pcrc_sdd0)
      call pcrc_delete_range (pcrc_irg1)
      call pcrc_delete_range (pcrc_irg0)
      pcrc_irg0 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &C,1))
      call pcrc_loop_bounds (pcrc_irg0,pcrc_lil_k,pcrc_liu_k,pcrc_lis_k)

      pcrc_irg1 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &C,2))
      call pcrc_loop_bounds (pcrc_irg1,pcrc_lil_l,pcrc_liu_l,pcrc_lis_l)

      pcrc_sdd0 = pcrc_new_array_section (2,pcrc_dad_C)
      call pcrc_set_array_triplet (pcrc_sdd0,1,1,100,1,pcrc_dad_C,1)
      call pcrc_set_array_triplet (pcrc_sdd0,2,1,100,1,pcrc_dad_C,2)
      call pcrc_coef (pcrc_dad_C,1,1,100,1,1,0,0,pcrc_u00,pcrc_v00)
      call pcrc_coef (pcrc_dad_C,2,1,100,1,1,0,0,pcrc_u01,pcrc_v01)
      call pcrc_coef (pcrc_dad_B,1,1,100,1,1,3,0,pcrc_u10,pcrc_v10)
      call pcrc_coef (pcrc_dad_B,2,1,100,1,1,1,0,pcrc_u11,pcrc_v11)
      pcrc_sdx0 = pcrc_v00+pcrc_v01
      pcrc_sdx1 = pcrc_v10+pcrc_v11
      if (pcrc_on (pcrc_group (pcrc_sdd0))) then 
          do  l=0,(pcrc_liu_l-pcrc_lil_l)/pcrc_lis_l,1
            pcrc_tmp_sdx01 = pcrc_sdx0
            pcrc_tmp_sdx11 = pcrc_sdx1
            do  k=0,(pcrc_liu_k-pcrc_lil_k)/pcrc_lis_k,1
               C(pcrc_sdx0) = B(pcrc_sdx1)
               pcrc_sdx1 = pcrc_sdx1+pcrc_u10
               pcrc_sdx0 = pcrc_sdx0+pcrc_u00
            enddo
            pcrc_sdx1 = pcrc_tmp_sdx11+pcrc_u11
            pcrc_sdx0 = pcrc_tmp_sdx01+pcrc_u01
         enddo
       endif
      call pcrc_delete_array (pcrc_sdd0)
      call pcrc_delete_range (pcrc_irg1)
      call pcrc_delete_range (pcrc_irg0)
      pcrc_irg0 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &A,1))
      call pcrc_loop_bounds (pcrc_irg0,pcrc_lil_k,pcrc_liu_k,pcrc_lis_k)

      pcrc_sdd0 = pcrc_new_array_section (1,pcrc_dad_A)
      call pcrc_set_array_triplet (pcrc_sdd0,1,1,100,1,pcrc_dad_A,1)
      call pcrc_coef (pcrc_dad_A,1,1,100,1,1,0,0,pcrc_u00,pcrc_v00)
      pcrc_sdx0 = pcrc_v00
      if (pcrc_on (pcrc_group (pcrc_sdd0))) then 
          do  k=0,(pcrc_liu_k-pcrc_lil_k)/pcrc_lis_k,1
            A(pcrc_sdx0) = 1
            pcrc_sdx0 = pcrc_sdx0+pcrc_u00
         enddo
       endif
      call pcrc_delete_array (pcrc_sdd0)
      call pcrc_delete_range (pcrc_irg0)
      pcrc_irg0 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &B,2))
      call pcrc_loop_bounds (pcrc_irg0,pcrc_lil_k,pcrc_liu_k,pcrc_lis_k)

      pcrc_sdd0 = pcrc_new_array_section (1,pcrc_dad_B)
      call pcrc_set_array_scalar (pcrc_sdd0,1,pcrc_dad_B,1)
      call pcrc_set_array_triplet (pcrc_sdd0,1,1,100,1,pcrc_dad_B,2)
      call pcrc_coef (pcrc_dad_B,1,1,1,1,1,0,0,pcrc_u00,pcrc_v00)
      call pcrc_coef (pcrc_dad_B,2,1,100,1,1,0,0,pcrc_u01,pcrc_v01)
      call pcrc_coef (pcrc_dad_A,1,1,100,1,2,0,0,pcrc_u10,pcrc_v10)
      pcrc_sdx0 = pcrc_v00+pcrc_v01
      pcrc_sdx1 = pcrc_v10
      if (pcrc_on (pcrc_group (pcrc_sdd0))) then 
          do  k=0,(pcrc_liu_k-pcrc_lil_k)/pcrc_lis_k,1
            B(pcrc_sdx0) = A(pcrc_sdx1)
            pcrc_sdx1 = pcrc_sdx1+pcrc_u10
            pcrc_sdx0 = pcrc_sdx0+pcrc_u01
         enddo
       endif
      call pcrc_delete_array (pcrc_sdd0)
      call pcrc_delete_range (pcrc_irg0)
      pcrc_irg0 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &B,1))
      call pcrc_loop_bounds (pcrc_irg0,pcrc_lil_k,pcrc_liu_k,pcrc_lis_k)

      pcrc_irg1 = pcrc_new_range_loop (1,100,1,1,0,pcrc_range (pcrc_dad_&
     &B,2))
      call pcrc_loop_bounds (pcrc_irg1,pcrc_lil_l,pcrc_liu_l,pcrc_lis_l)

      pcrc_sdd0 = pcrc_new_array_section (2,pcrc_dad_B)
      call pcrc_set_array_triplet (pcrc_sdd0,1,1,100,1,pcrc_dad_B,1)
      call pcrc_set_array_triplet (pcrc_sdd0,2,1,100,1,pcrc_dad_B,2)
      call pcrc_coef (pcrc_dad_B,1,1,100,1,1,0,0,pcrc_u00,pcrc_v00)
      call pcrc_coef (pcrc_dad_B,2,1,100,1,1,0,0,pcrc_u01,pcrc_v01)
      pcrc_sdx0 = pcrc_v00+pcrc_v01
      if (pcrc_on (pcrc_group (pcrc_sdd0))) then 
          do  l=0,(pcrc_liu_l-pcrc_lil_l)/pcrc_lis_l,1
            pcrc_tmp_sdx01 = pcrc_sdx0
            do  k=0,(pcrc_liu_k-pcrc_lil_k)/pcrc_lis_k,1
               B(pcrc_sdx0) = 1
               pcrc_sdx0 = pcrc_sdx0+pcrc_u00
            enddo
            pcrc_sdx0 = pcrc_tmp_sdx01+pcrc_u01
         enddo
       endif
      call pcrc_delete_array (pcrc_sdd0)
      call pcrc_delete_range (pcrc_irg1)
      call pcrc_delete_range (pcrc_irg0)
      call pcrc_delete_array (pcrc_dad_D)
      call pcrc_delete_array (pcrc_dad_C)
      call pcrc_delete_array (pcrc_dad_B)
      call pcrc_delete_array (pcrc_dad_A)
      call pcrc_delete_range (pcrc_rng_TMP002(3))
      call pcrc_delete_range (pcrc_rng_TMP002(2))
      call pcrc_delete_range (pcrc_rng_TMP002(1))
      call pcrc_delete_range (pcrc_rng_TMP001(2))
      call pcrc_delete_range (pcrc_rng_TMP001(1))
      call pcrc_delete_range (pcrc_rng_TMP000(1))
      call pcrc_delete_group (pcrc_grp_PROC000)
      call pcrc_finalize ()
      end program


