#ifndef _XSIMPLEUTIL_H
#define _XSIMPLEUTIL_H

typedef struct _xu_menu_button_struct{
        char    *name;        /* name of menu item */
	char	mnemonic;     /* mnemonic character */
        void    (*func)();    /* callback to be invoked */
        caddr_t data;         /* data for the callback */
        struct _xu_menu_button_struct *sub_menu;  /* data forthe sub_menu */
        int     n_sub_items;  /* items in the sub_menu */
        char    *sub_menu_title; /* Title of submenu */
	Widget  *ret_widget;	/* corresponding widget */
	WidgetClass  widgetClass; /* specify the expected widget class */
        } MenuButtonsStruct;

typedef struct EventListStruct
{
	XEvent event;
	struct EventListStruct *link;
}
EventList, *EventListPtr;

typedef struct ButtonStatusStruct 
{
	int background;
	int time;
} ButtonStatus;

#define ALL_EVENT_MASK 0xffff

#define USER_INTERACTION_MASK (KeyPressMask | KeyReleaseMask | \
	ButtonPressMask | ButtonReleaseMask | \
	PointerMotionMask | ButtonMotionMask)

#define NO_INTERACTION_MASK (ALL_EVENT_MASK & ~USER_INTERACTION_MASK)

#define ASK_YES  1
#define ASK_NO   2
#define ASK_CANCEL  3

void XuWidgetPrintf();
void XuTextPrintf();
void XuMessageBoxPrintf();
String XuWidgetGets();
void XuCreateMenuButtons();

#endif
