/***********************************************************************/
/*                                                                     */
/*             Define type and const for EasyCAD                       */
/*                                                 		       */
/***********************************************************************/

#ifndef _XAPP_H
#define _XAPP_H

#define _NO_PROTO

#define MAXARGS 50
#define MAXNAMESIZE 32

#define SUCCESS 0
#define FAILURE -1

/*   dependance   */
/*
		string.h  or strings.h ? , I am not sure .so exclude it
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
/* #include <stdlib.h> */
#include <math.h>

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>

#include <Xm/Xm.h>

/* useful widget */
#include <Xm/ArrowBP.h>
#include <Xm/ArrowBGP.h>
#include <Xm/BulletinBP.h>
#include <Xm/CascadeBP.h>
#include <Xm/CascadeBGP.h>
#include <Xm/DialogSP.h>
#include <Xm/DrawingAP.h>
#include <Xm/DrawnBP.h>
#include <Xm/FileSBP.h>
#include <Xm/FormP.h>
#include <Xm/FrameP.h>
#include <Xm/LabelP.h>
#include <Xm/LabelGP.h>
#include <Xm/List.h>
#include <Xm/ListP.h>
#include <Xm/MainWP.h>
#include <Xm/MessageBP.h>
#include <Xm/PanedW.h>
#include <Xm/PushBGP.h>
#include <Xm/PushBP.h>
#include <Xm/RowColumnP.h>
#include <Xm/Scale.h>
#include <Xm/ScrolledWP.h>
#include <Xm/ScrollBarP.h>
#include <Xm/SelectioBP.h>
#include <Xm/SeparatoGP.h>
#include <Xm/TextP.h>
#include <Xm/ToggleBGP.h>
#include <Xm/ToggleBP.h>

#include <Xm/Protocols.h>

#endif
