#define _CPP
#define _RUNTIME
#define _GLOBAL
#include "headers.h"

int main()
{
	int nProcNum=4;
	int nStmtID;
	
	for (int nProcID=0; nProcID<4; nProcID++)
	{
		ProfBegin(nProcID, nProcNum);
		
		for (int s=2; s<4; s+=2)
		{
		//	emulate a parallel statement
			int limit1=rand()%10;
			for (int k=0; k<limit1; k++)
			{
				ProfPushStack(s);
				//	delay
				int limit2=rand()%100000;
				int t;
				for (int j=0; j<limit2; j++) t=j*2;

				ProfBeginCom();

				gr_nRemap++;
				gr_nRemapAmount+=rand() % 1000;
				gr_nShift++;
				gr_nShiftAmount+=rand() % 1000;

				for (int p=0; p<8; p++)
				{
					if (p==nProcID) continue;
					int bSend=rand() %2;
					if (bSend)
					{
						int nSend=rand() % 1000;
						ProfNewEvent(stat_send, p, nSend);
						gr_aSend[p]++;
						gr_aSendAmount[p]+=nSend;
						ProfEndEvent(stat_send);
					}

					int bRecv=rand() %2;
					if (bRecv)
					{
						int nRecv=rand() % 1000;
						ProfNewEvent(stat_recv, p, nRecv);
						gr_aRecv[p]++;
						gr_aRecvAmount[p]+=nRecv;
						ProfEndEvent(stat_recv);
					}
				}

				ProfEndCom();
	
				int limit=rand()%32767;
				for (int i=0; i<limit; i++)
					gr_nLoopCounter++;
				ProfPopStack();
			}
		}

		ProfEnd();
	}
}
