//
//	RunTimeP.h
//		private header for prof data collection implementation
//		not visible in HPF compiler and Adlib code
//

#ifndef _RUNTIMEP_H
#define _RUNTIMEP_H

///////////////////////////////////////////
//	define pointer class to CParaStmtInfo
typedef CParaStmtInfo *PtrParaStmtInfo;

/////////////////////////////////////////
//	global variables
extern stack < vector <PtrParaStmtInfo> > g_stParaStmt;
		//	stack of active parallel statement

extern CProcInfo g_procInfo;
		//	global CProcInfo object to store all prof data


/////////////////////////////////////////
//	functions
BOOL SaveCurState(CParaStmtInfo *pParaStmt);
BOOL RestoreState(CParaStmtInfo *pParaStmt);

#endif
