      PROGRAM LAPLACE
      PARAMETER(N=12)
      PARAMETER(Nsteps = 10)
      INTEGER N,Nsteps
      INTEGER i,j,k
      REAL A(N,N),B(N,N),C(N,N),tolerence,error
      INTEGER niter,nicycle,x,y
      INTEGER toler(2)
!!HPF$ PROCESSORS PROC(4)
!HPF$ PROCESSORS PROC(2,2)
!HPF$ TEMPLATE TEMP(N,N) 
!!HPF$ DISTRIBUTE TEMP(*,BLOCK) ONTO PROC
!!HPF$ DISTRIBUTE TEMP(BLOCK,*) ONTO PROC
!HPF$ DISTRIBUTE TEMP(BLOCK,BLOCK) ONTO PROC
!HPF$ ALIGN A(i,j) with TEMP(i,j)
!HPF$ ALIGN B(i,j) with TEMP(i,j)
!HPF$ ALIGN C(i,j) with TEMP(i,j)
!HPF$ OUT_OF_CORE    A,B,C

      print *,"  "
      print *, "Laplace Jacobi,step=",Nsteps,"size=",N,"*",N,"(BLOCK,*)"
!      call pcrc_clock(0)
      FORALL (i=1:N,j=1:N)     A(i,j) = 8.0
      FORALL (i=2:N-1,j=2:N-1) A(i,j) = 2.0
      print *, 'Start grid looks like'
      DO I= 2, N-1
        WRITE(*,101) (A(I,J),J=2,N-1)
      END DO
      B = A
      C = A
      DO k = 1, Nsteps
      !  FORALL (i=2:N-1,j=2:N-1) A(i,j) = 
                    ! (A(i,j+1) + A(i,j-1)+A(i-1,j)+A(i+1,j) ) * 0.25
        FORALL (i=2:N-1,j=2:N-1) B(i,j) = (A(i,j-1) + A(i,j+1) ) * 0.25
        FORALL (i=2:N-1,j=2:N-1) B(i,j)=B(i,j)+(A(i-1,j)+ A(i+1,j))*0.25
        A=B
      END DO
!      call pcrc_clock(1)
      print *, 'Final grid looks like'
      DO I= 2, N-1
        WRITE(*,101) (A(I,J),J=2,N-1)
      END DO
!	WRITE(*,101) ((A(I,J),J=1,N/2),I=1,N/2)
!	STOP
 101  FORMAT(12F9.3)
      END
