      PROGRAM WEIGHT 
      INTEGER N
      PARAMETER(N=20)
      PARAMETER(Nsteps = 1)
      INTEGER i,j,k
      REAL A(N,N),B(N,N)

      INTERFACE
        SUBROUTINE TEMP3x3(A,N)
          INTEGER,INTENT(IN)                 :: N
          REAL,DIMENSION(N,N),INTENT(INOUT)  :: A
!HPF$     DISTRIBUTE *(*,BLOCK)              :: A
!HPF$ OUT_OF_CORE			A
!HPF$ SHADOW  A(1:1,1:1)
        END SUBROUTINE TEMP3x3
      END INTERFACE

!HPF$ PROCESSORS PROC(4)
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC   :: A,B
!HPF$ OUT_OF_CORE                 A
!HPF$ SHADOW  A(1:1,1:1)

      FORALL (i=1:N,j=1:N)     A(i,j) = 8.0
      FORALL (i=2:N-1,j=2:N-1) A(i,j) = 2.0
      print *, 'Start grid looks like'
      do i=1,N
      write(*,30) (A(i,j),j=1,N)
      enddo

!      print *,"  "
!     print *, "Weighted sum solver,step=",Nsteps,"size=",N

!      call pcrc_clock(0)
      CALL TEMP3x3(A,N)
!      call pcrc_clock(1)

      print *, 'Final grid looks like'
      do i=1,N
      write(*,30) (A(i,j),j=1,N)
      enddo
30    FORMAT(100F10.5)
      END

      SUBROUTINE TEMP3x3(A,N)
      INTEGER,INTENT(IN)                 :: N
      REAL,DIMENSION(N,N),INTENT(INOUT)  :: A
      REAL B(N,N)
      INTEGER i,j
!HPF$ DISTRIBUTE (*,BLOCK)               :: B
!HPF$ DISTRIBUTE *(*,BLOCK)              :: A
!HPF$ OUT_OF_CORE			A,B
!HPF$ SHADOW  A(1:1,1:1)

      B=A
!234567890123456789012345678901234567890123456789012345678901234567890123
      FORALL(i=2:N-1,j=2:N-1) B(i,j)=(A(i-1,j-1)+A(i-1,j)+A(i-1,j+1)    &
     &       +A(i,j-1)+A(i,j+1)+A(i+1,j-1)+A(i+1,j)+A(i+1,j+1))/9.0
      A=B
      RETURN
      END 
